package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ShopAgreement;
import com.izouma.awesomeadmin.service.ShopAgreementService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/shopAgreement")
@RequiresAuthentication
public class ShopAgreementController {

    @Autowired
    private ShopAgreementService shopAgreementService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ShopAgreement record) {
        List<ShopAgreement> pp = shopAgreementService.getShopAgreementList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getShopAgreement", method = RequestMethod.GET)
    @ResponseBody
    public Result getShopAgreement(@RequestParam(required = false, value = "id") String id) {
        ShopAgreement data = shopAgreementService.getShopAgreementById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ShopAgreement record) {
        ShopAgreement data = shopAgreementService.getShopAgreement(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ShopAgreement record) {
        Map<String, Object> result = new HashMap<>();

        List<ShopAgreement> pp =shopAgreementService.getShopAgreementByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ShopAgreement record) {
        boolean num = shopAgreementService.createShopAgreement(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateShopAgreement(ShopAgreement record) {
        boolean num = shopAgreementService.updateShopAgreement(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteShopAgreement(@RequestParam(required = true, value = "id") String id) {

        boolean num = shopAgreementService.deleteShopAgreement(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ShopAgreement record) throws Exception {

    List<ShopAgreement> shopAgreements = shopAgreementService.getShopAgreementList(record);


        String sheetName = "shop_agreement";
        String titleName = "开店协议数据表";
        String fileName = "开店协议表";
        int columnNumber = 8;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "协议" ,   "备注"  };
        String[][] dataList = new String[shopAgreements.size()][8];

        for (int i = 0; i < shopAgreements.size(); i++) {

                        dataList[i][0] = String.valueOf(shopAgreements.get(i).getId());
                        dataList[i][1] = String.valueOf(shopAgreements.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(shopAgreements.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(shopAgreements.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(shopAgreements.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(shopAgreements.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(shopAgreements.get(i).getAgreement());
                        dataList[i][7] = String.valueOf(shopAgreements.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

